%define __python %{__python3}

Name:           rhui-installer
Version:        4.1.0.4
Release:        1%{?dist}
Summary:        Ansible based installer for RHUI
Group:          Applications/System
License:        GPLv3+ and ASL 2.0
URL:            http://redhat.com
Source0:        %{name}-%{version}.tar.gz

BuildArch:      noarch
BuildRequires:  python3-setuptools
Requires:       python36
Requires:       ansible
Requires:       ansible-collection-community-crypto
Requires:       python3-pyyaml >= 5.1

%description
A set of tools for installation of RHUI.

%prep
%setup -q -n rhui-installer-%{version}

%build
pushd src
%{__python} setup.py build
popd

%install
rm -rf $RPM_BUILD_ROOT

# Python setup
pushd src
%{__python} setup.py install -O1 --skip-build --root %{buildroot}
popd
rm -f $RPM_BUILD_ROOT%{python_sitelib}/rhui*egg-info/requires.txt
find $RPM_BUILD_ROOT -name '*.pyc' -delete
rm -f $RPM_BUILD_ROOT/usr/lib/python3.6/site-packages/rhui/__init__.py

install -d -m0755 %{buildroot}%{_localstatedir}/log/rhui/rhui-installer
install -d -m0755 %{buildroot}/%{_datadir}/rhui-installer
cp -dpR playbooks %{buildroot}/%{_datadir}/rhui-installer
cp -dpR templates %{buildroot}/%{_datadir}/rhui-installer

%files
%defattr(-,root,root,-)
%{python_sitelib}/rhui/*
%{python_sitelib}/rhui*.egg-info
%dir %{_localstatedir}/log/rhui/rhui-installer
%{_bindir}/rhui-installer
%{_datadir}/rhui-installer/playbooks
%{_datadir}/rhui-installer/templates

%changelog
* Thu Mar 10 2022 Sebastian Skracic <sskracic@redhat.com> 4.1.0.4-1
- Change the default log level in the installer (pbartiko@redhat.com)
- legacy_ca_dir parameter has to be in rhui-tools.conf so that it is not
  overwritten every-time cds is reinstalled. (mminar@redhat.com)

* Wed Mar 09 2022 Sebastian Skracic <sskracic@redhat.com> 4.1.0.3-1
- Pulp 3.17 / Python 3.8 compatibility changes (sskracic@redhat.com)

* Fri Mar 04 2022 Sebastian Skracic <sskracic@redhat.com> 4.1.0.2-1
- Expand any specifie cephfs_secretkey_file argument to an absolute path.
  (jvlcek@redhat.com)
- Update installer to use ceph secretfile. (jvlcek@redhat.com)

* Fri Mar 04 2022 Sebastian Skracic <sskracic@redhat.com> 4.1.0.1-1
- PEP-8 compliance clean-up. Changing class name to CamelCase, reformating
  lines so they are shorter than 120 and line-up properly with braces. Adding
  two lines between functions. Changing one liners - so that linter doesn't
  complain. ;) Adding exact exception to except. (mminar@redhat.com)
- Cleanup of unnecessary imports. (mminar@redhat.com)
- Remove other from valid options. (mminar@redhat.com)

* Thu Feb 17 2022 Sebastian Skracic <sskracic@redhat.com> 4.1.0.0-1
- 

* Wed Feb 09 2022 Sebastian Skracic <sskracic@redhat.com> 4.0.1.3-1
- Add ceph support to cds configure (jvlcek@redhat.com)
- Add support for CephFS (jvlcek@redhat.com)

* Thu Feb 03 2022 Sebastian Skracic <sskracic@redhat.com> 4.0.1.2-1
- Initialize the Logger.log_file before accessing it. (jvlcek@redhat.com)

* Fri Dec 17 2021 Sebastian Skracic <sskracic@redhat.com> 4.0.1.1-1
- RHUI-139: FIPS compliance (sskracic@redhat.com)

* Tue Dec 14 2021 Sebastian Skracic <sskracic@redhat.com> 4.0.1.0-1
- Set ansible log in rhui directory and fix typos (jvlcek@redhat.com)
- Capture ansible playbook output in rhui install log file (jvlcek@redhat.com)
- Add logging value into the `rhui-tools.conf` file (pbartiko@redhat.com)

* Tue Oct 26 2021 Sebastian Skracic <sskracic@redhat.com> 4.0.0.16-1
- RHUI-132 Add NginX restart when new CA cert is provided. (jvlcek@redhat.com)

* Fri Oct 08 2021 Sebastian Skracic <sskracic@redhat.com> 4.0.0.15-1
- Add Install python3-policycoreutils to the installer playbook.
  (jvlcek@redhat.com)

* Fri Oct 01 2021 Sebastian Skracic <sskracic@redhat.com> 4.0.0.14-1
- Invalidate an active login session when changing the password
  (jvlcek@redhat.com)

* Mon Sep 27 2021 Sebastian Skracic <sskracic@redhat.com> 4.0.0.13-1
- Implement rhui-manager password model (pbartiko@redhat.com)

* Thu Sep 09 2021 Sebastian Skracic <sskracic@redhat.com> 4.0.0.12-1
- Create RHUI_DIR as a pre-install step. (jvlcek@redhat.com)

* Mon Aug 16 2021 Sebastian Skracic <sskracic@redhat.com> 4.0.0.11-1
- Fix ordering and typing of the DEFAULTS dictionary (pbartiko@redhat.com)
- Input validation for the int arguments (pbartiko@redhat.com)
- Input validation for the --retain-package-versions argument
  (pbartiko@redhat.com)
- Implement --retain-package-versions parameter (pbartiko@redhat.com)
- Set user_supplied_ca_x to absolute paths (jvlcek@redhat.com)
- Fix glusterfs support (jvlcek@redhat.com)
- Add support for user supplied CA crt and key (jvlcek@redhat.com)
- add cds_certs_expiration to rhui-tools.conf (jvlcek@redhat.com)
- add certs_ca_expiration to playbook (jvlcek@redhat.com)
- Update template with proxy args (jvlcek@redhat.com)
- add back --rhua-mount-options (jvlcek@redhat.com)
- Create validators (jvlcek@redhat.com)
- Add and rename all args support for the 4.0 release (jvlcek@redhat.com)
- Integrate with Ansible playbooks (jvlcek@redhat.com)
- debug with cyan on default background (jvlcek@redhat.com)
- Set light backgroud color for black debug messages. (jvlcek@redhat.com)

* Tue Jul 27 2021 Sebastian Skracic <sskracic@redhat.com> 4.0.0.10-1
- RHUI-65 addendum: shared storage filesystem type must be honoured in CDS
  provisioning as well (sskracic@redhat.com)

* Tue Jul 27 2021 Sebastian Skracic <sskracic@redhat.com> 4.0.0.9-1
- RHUI-65: GlusterFS support in the installer (sskracic@redhat.com)

* Fri Jul 23 2021 Sebastian Skracic <sskracic@redhat.com> 4.0.0.8-1
- Improve error message text (jvlcek@redhat.com)
- Handle valid but empty user supplied answers file. (jvlcek@redhat.com)
- Confirm user provided answers file is valid yaml. (jvlcek@redhat.com)
- Add support for user supplied answers YAML file. (jvlcek@redhat.com)

* Tue Jul 20 2021 Sebastian Skracic <sskracic@redhat.com> 4.0.0.7-1
- Check required args for an empty string (jvlcek@redhat.com)
- Use exit codes (jvlcek@redhat.com)
- Move placement of exit for improved readability (jvlcek@redhat.com)
- Add space for readability (jvlcek@redhat.com)
- Complete the deploy_certs help string (jvlcek@redhat.com)
- Add support for rhua-hostname and cds-lb-hostname. (jvlcek@redhat.com)
- Create the .rhui dir and avoid hardcoding /root (jvlcek@redhat.com)
- Do not create the /etc/rhui-installer directory (jvlcek@redhat.com)
- Confirm remote_fs_server argument is provided. (jvlcek@redhat.com)
- Fix typo (jvlcek@redhat.com)
- Move doc string under method definition line (jvlcek@redhat.com)
- Use positional arguments for False to True flags. (jvlcek@redhat.com)
- Avoid avoid any to a concrete technolog and reinstate method save_answers
  (jvlcek@redhat.com)
- Add support for an existing answers.yaml file (jvlcek@redhat.com)
- Update answers.yaml file handling (jvlcek@redhat.com)
- Do not require remote-fs-server (jvlcek@redhat.com)
- Moving rhui-in-container to a separate Git repo:
  git@gitlab.sat.engineering.redhat.com:rhui4/rhui-in-container.git
  (sskracic@redhat.com)
- Integrate argument parsing for generate CA cert request with the playbook
  (jvlcek@redhat.com)

* Thu Jul 09 2021 Joseph VLcek <jvlcek@redhat.com> 4.0.0.7-1
- Avoid seeding the answers.yaml. (jvlcek@redhat.com)

* Tue Jul 06 2021 Sebastian Skracic <sskracic@redhat.com> 4.0.0.6-1
- 

* Tue Jul 06 2021 Sebastian Skracic <sskracic@redhat.com> 4.0.0.3-1
- Ensuring the REST API requests made by RHUI do not time out.
  (sskracic@redhat.com)

* Tue Jul 06 2021 Sebastian Skracic <sskracic@redhat.com>
- Ensuring the REST API requests made by RHUI do not time out.
  (sskracic@redhat.com)

* Thu Jul 01 2021 Sebastian Skracic <sskracic@redhat.com> 4.0.0.5-1
- The null values from args must be included in answers.yaml if the keys are
  not (yet) there. (sskracic@redhat.com)

* Thu Jul 01 2021 Sebastian Skracic <sskracic@redhat.com> 4.0.0.4-1
- Ensuring answers.yaml are overriden only with the actually supplied args.
  (sskracic@redhat.com)

* Wed Jun 30 2021 Sebastian Skracic <sskracic@redhat.com> 4.0.0.3-1
- The installer requires more recent version of PyYAML. (sskracic@redhat.com)


* Wed Jun 30 2021 Sebastian Skracic <sskracic@redhat.com> 4.0.0.2-1
- Introducing new RHUI4 Ansible-based installer

* Mon Mar 09 2020 Martin Minar <mminar@redhat.com> 3.1.5-1
- [Bz 1637261][RFE] Hardening of RHUI We are disabling TLS1 and TLS1.1 allowing
  only TLS1.2 protocols on CDS. It is still possible to change that manually
  back in Apache configuration. RHEL5 clients won't be able to communicate with
  CDS that has this change applied as RHEL5 only supports up to TLS1.
  (pbartiko@redhat.com)

* Tue Nov 12 2019 Martin Minar <mminar@redhat.com> 3.1.3-3
- Package python-crane was renamed to python2-crane to better distinguish
  python2 and python3 in future and while it still provides python-crane,
  puppet is not able to locate it in repo due to changed name - fixing that.
  (mminar@redhat.com)

* Mon Nov 11 2019 Martin Minar <mminar@redhat.com> 3.1.3-1
- [BZ 1692119] Enable syncing of multiple registries, add an option to change
  them in UI (mminar@redhat.com)

* Wed Apr 03 2019 Martin Minar 3.1.0-1
- Puppet modules updated for new oid validator. (mminar@redhat.com)

* Thu Aug 23 2018 Milan Kubík <mkubik@redhat.com> 3.0.2-1
- [BZ 1489113] - [RFE] RHUI 3 repo_importers not configured for remove_missing
  (mkubik@redhat.com)

* Thu May 10 2018 Milan Kubík <mkubik@redhat.com> 3.0.1-1
- update wording of the installer message (mkubik@redhat.com)
- bz148572 - Added instruction messages to the installer (mkubik@redhat.com)
- Update the rhui-installer with latest modules (mkubik@redhat.com)

* Tue Jan 24 2017 B Zhang <bizhang@redhat.com> 3.0.0-1
- bumping version to 3.0.0 (bizhang@redhat.com)

* Tue Dec 13 2016 B Zhang <bizhang@redhat.com> 0.0.44-1
- 

* Tue Nov 22 2016 B Zhang <bizhang@redhat.com> 0.0.43-1
- Validate only positive integers (exclude 0) (pcreech@redhat.com)

* Tue Nov 15 2016 B Zhang <bizhang@redhat.com> 0.0.42-1
- Validate expiration dates (pcreech@redhat.com)

* Tue Nov 15 2016 B Zhang <bizhang@redhat.com> 0.0.41-1
- Fix docker certificate issue (pcreech@redhat.com)
- update changelog with name (bizhang@redhat.com)

* Thu Nov 10 2016 B Zhang <bizhang@redhat.com> 0.0.40-1
- Fixing issue in cds module (pcreech@redhat.com)

* Wed Nov 09 2016 B Zhang 0.0.39-1
- Update puppet-cds (pcreech@redhat.com)
- Update crane module to latest (pcreech@redhat.com)
- Update katello-crane (pcreech@redhat.com)

* Wed Nov 09 2016 B Zhang
- Update puppet-cds (pcreech@redhat.com)
- Update crane module to latest (pcreech@redhat.com)
- Update katello-crane (pcreech@redhat.com)

* Tue Oct 25 2016 B Zhang 0.0.37-1
- Save RPM to protected/unprotected relative path (bizhang@redhat.com)

* Wed Sep 21 2016 Patrick Creech <pcreech@redhat.com> 0.0.36-1
- Don't use passenger for puppetmaster (pcreech@redhat.com)

* Tue Aug 30 2016 B Zhang <bizhang@redhat.com> 0.0.35-1
- Removing indentation (pcreech@redhat.com)

* Tue Aug 09 2016 Patrick Creech <pcreech@redhat.com> 0.0.34-1
- Include answer file in error message (pcreech@redhat.com)

* Wed Jul 27 2016 Patrick Creech <pcreech@redhat.com> 0.0.33-1
- Fixing srl extension (pcreech@redhat.com)

* Tue Jul 26 2016 Patrick Creech <pcreech@redhat.com> 0.0.32-1
- Fix mispelling in entitlement (pcreech@redhat.com)

* Tue Jul 19 2016 Patrick Creech <pcreech@redhat.com> 0.0.31-1
- Fix installer return code (pcreech@redhat.com)
- Generate entitilement-ca.srl (pcreech@redhat.com)
- Increasing the minimum worker count for pulp (pcreech@redhat.com)

* Tue Jul 12 2016 Patrick Creech <pcreech@redhat.com> 0.0.30-1
- Disabling TRACE on CDS servers (pcreech@redhat.com)

* Thu Jul 07 2016 Patrick Creech <pcreech@redhat.com> 0.0.29-1
- Updating puppet-rhua to turn off track/trace (pcreech@redhat.com)

* Tue May 17 2016 Patrick Creech <pcreech@redhat.com> 0.0.28-1
- Pinning more module versions (pcreech@redhat.com)

* Fri May 13 2016 Patrick Creech <pcreech@redhat.com> 0.0.27-1
- Pinning puppetlabs stdlib (pcreech@redhat.com)

* Fri May 13 2016 Patrick Creech <pcreech@redhat.com> 0.0.26-1
- Rebuilding installer with pinned versions (pcreech@redhat.com)
- Pinning module versions (pcreech@redhat.com)

* Thu May 12 2016 Patrick Creech <pcreech@redhat.com> 0.0.25-1
- Upstream updates for RHUA (pcreech@redhat.com)

* Wed Oct 07 2015 Chris Duryee <cduryee@redhat.com> 0.0.24-1
- upstream updates for RHUA (cduryee@redhat.com)

* Wed Oct 07 2015 Chris Duryee <cduryee@redhat.com> 0.0.23-1
- more RHUA updates (cduryee@redhat.com)

* Wed Oct 07 2015 Chris Duryee <cduryee@redhat.com> 0.0.22-1
- upstream RHUA module changes (cduryee@redhat.com)

* Tue Oct 06 2015 Chris Duryee <cduryee@redhat.com> 0.0.21-1
- updates for RHUA module (cduryee@redhat.com)

* Tue Sep 15 2015 Chris Duryee <cduryee@redhat.com> 0.0.20-1
- update to puppet stdlib (cduryee@redhat.com)
- Added the user management screen back to rhui-manager (jeremy@jcline.org)
- Added validation hooks for proxy and FS server settings. (jeremy@jcline.org)

* Tue Sep 08 2015 Chris Duryee <cduryee@redhat.com> 0.0.19-1
- additional update to RHUA puppet module (cduryee@redhat.com)

* Tue Sep 08 2015 Chris Duryee <cduryee@redhat.com> 0.0.18-1
- puppet updates to support password on installer (cduryee@redhat.com)
- The default pulp password is now generated or set at install-time.
  (jeremy@jcline.org)

* Thu Sep 03 2015 Chris Duryee <cduryee@redhat.com> 0.0.17-1
- rhua puppet updates (cduryee@redhat.com)

* Wed Sep 02 2015 Chris Duryee <cduryee@redhat.com> 0.0.16-1
- proxy erb file fixups (cduryee@redhat.com)

* Wed Sep 02 2015 Chris Duryee <cduryee@redhat.com> 0.0.15-1
- puppet changes for cert regen and proxy fixes (cduryee@redhat.com)

* Tue Sep 01 2015 Chris Duryee <cduryee@redhat.com> 0.0.14-1
- puppet-rhua updates from upstream (cduryee@redhat.com)
- rhui-installer no longer offers the certs module. (jeremy@jcline.org)
- Update rhui-installer with a collection of hooks. (jeremy@jcline.org)

* Fri Aug 28 2015 Chris Duryee <cduryee@redhat.com> 0.0.13-1
- puppet update for rhua proxy fix (cduryee@redhat.com)
- update to add haproxy dependency (cduryee@redhat.com)

* Thu Aug 27 2015 Chris Duryee <cduryee@redhat.com> 0.0.12-1
- updates for rhua and cds puppet modules (cduryee@redhat.com)

* Wed Aug 19 2015 Chris Duryee <cduryee@redhat.com> 0.0.11-1
- updates to fix bugs in cds and rhua setup (cduryee@redhat.com)

* Wed Aug 19 2015 Chris Duryee <cduryee@redhat.com> 0.0.10-1
- puppet updates for rhua/cds from upstream for NFS config (cduryee@redhat.com)

* Mon Aug 17 2015 Chris Duryee <cduryee@redhat.com> 0.0.9-1
- upstream puppet updates (cduryee@redhat.com)

* Wed Aug 12 2015 Chris Duryee <cduryee@redhat.com> 0.0.8-1
- upstream puppet updates (cduryee@redhat.com)

* Fri Aug 07 2015 Chris Duryee <cduryee@redhat.com> 0.0.7-1
- update puppet modules from upstream (cduryee@redhat.com)

* Thu Aug 06 2015 Chris Duryee <cduryee@redhat.com> 0.0.6-1
- updates from upstream puppet modules (cduryee@redhat.com)

* Tue Aug 04 2015 Chris Duryee <cduryee@redhat.com> 0.0.5-1
- upstream puppet updates (cduryee@redhat.com)
- Removed the last vestiges of the identity certificate (jeremy@jcline.org)

* Tue Jul 28 2015 Chris Duryee <cduryee@redhat.com> 0.0.4-1
- updates from upstream puppet modules (cduryee@redhat.com)

* Tue Jul 28 2015 Chris Duryee <cduryee@redhat.com> 0.0.3-1
- new package built with tito (old one had wrong name)

* Tue Jul 28 2015 Chris Duryee <cduryee@redhat.com> 0.0.2-1
- new package built with tito


